// ChangePass.cpp : implementation file
//

#include "stdafx.h"
#include "PAMPlugin.h"
#include "ChangePass.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangePass dialog


CChangePass::CChangePass(CWnd* pParent /*=NULL*/)
	: CDialog(CChangePass::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangePass)
	m_pass1 = _T("");
	m_pass2 = _T("");
	m_message = _T(PAMPLUGIN_ABOUT);
	//}}AFX_DATA_INIT
}


void CChangePass::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangePass)
	DDX_Control(pDX, IDC_PASS1, m_pass1ctl);
	DDX_Text(pDX, IDC_PASS1, m_pass1);
	DDX_Text(pDX, IDC_PASS2, m_pass2);
	DDX_Text(pDX, ID_MESSAGES, m_message);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangePass, CDialog)
	//{{AFX_MSG_MAP(CChangePass)
	ON_BN_CLICKED(IDOK, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangePass message handlers

void CChangePass::OnApply() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE); // get the data
	if(m_pass1 != m_pass2)
	{
		m_message = "Your new passwords do not match, please try again.";
		m_pass1 = "";
		m_pass2 = "";
		m_pass1ctl.SetFocus();
		// TODO: Set focus to IDC_PASS1
		UpdateData(FALSE);
	}
	else
	{
		CString glo = glPassword;
		if(m_pass1 != glo)
		{
			glPassword = strdup(m_pass1.GetBuffer(m_pass1.GetLength()));
			CDialog::OnOK();
		}
		else
		{
			m_message = "You cannot use the same password you had previously set. Please choose another.";
			m_pass1 = "";
			m_pass2 = "";
			m_pass1ctl.SetFocus();
			UpdateData(FALSE);
		}
	}
}

void CChangePass::OnCancel() 
{
	// TODO: Add extra cleanup here
	glPassword = NULL;
	CDialog::OnCancel();
}
