// ConfigDialog.cpp : implementation file
//

#include "stdafx.h"
#include "NISplugin.h"
#include "ConfigDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog dialog


CConfigDialog::CConfigDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigDialog)
	m_domain = _T("");
	m_map = _T("");
	//}}AFX_DATA_INIT
	m_domain = regReadString(TEXT("Default NIS Domain"));
	m_map = regReadString(TEXT("NIS Password Map"));
	if(m_map.GetLength() == 0)
	{
		m_map = TEXT("passwd.byname");
		regWriteString(TEXT("passwd.byname"),TEXT("NIS Password Map"));
	}
}


void CConfigDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDialog)
	DDX_Text(pDX, IDC_HOST, m_domain);
	DDX_Text(pDX, IDC_MAP, m_map);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDialog, CDialog)
	//{{AFX_MSG_MAP(CConfigDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog message handlers

void CConfigDialog::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	regWriteString(m_domain.GetBuffer(m_domain.GetLength()),TEXT("Default NIS Domain"));
	regWriteString(m_map.GetBuffer(m_map.GetLength()),TEXT("NIS Password Map"));
	

	CDialog::OnOK();
}
