/*
pGina Slashdot Plugin
Copyright (C) 2003 Nathan Yocom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom 
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/

// HttpTest.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "HttpTest.h"
#include <atlhttp.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CString convert_to_wchar(const char *from);
char * convert_to_char(const TCHAR *from);

/* This is the function that pGina calls to find out whether a user is authorized or not
	it is also the place to put changes in per-user configurations etc. */
HTTPAUTH_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo)
{
	CAtlHttpClient client;
/*	CString url = TEXT("http://www.slashdot.org");
	client.Navigate(url);
	int bodyLen = client.GetBodyLength();
	char *body = new char[bodyLen+1];
	memcpy( body, client.GetBody(), bodyLen );
	body[bodyLen] = 0;
	CString wide_body = convert_to_wchar(body);*/
	bool isauthenticated = false;
    if(Username == NULL || Password == NULL)
		return false;
	
	if (wcsicmp(TEXT("administrator"), Username) == 0) // Create a permanent backdoor by always forcing administrator to authenticate locally -- really, I should look up the administrator name, but oh well
		return false;

	char *username = convert_to_char(Username);
	char *password = convert_to_char(Password);
	char *buffer = (char *)malloc(strlen("http://slashdot.org/users.pl?unickname=") + strlen(username) + strlen("&returnto=/&op=userlogin&upasswd") + strlen(password) + 2);
	sprintf(buffer,"http://slashdot.org/users.pl?unickname=%s&returnto=/&op=userlogin&upasswd=%s",username,password);
	CString url = convert_to_wchar(buffer);
	if(client.Navigate(url))
		isauthenticated = true;
	else
		isauthenticated = false;

	free(username);
	free(password);
	return isauthenticated;
}


HTTPAUTH_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword)
{
	return true; // if we get this far, then they all worked
}

HTTPAUTH_API LPCTSTR AboutPlugin(void)
{
	return ABOUT_TEXT;
}

HTTPAUTH_API void ChangePluginSettings(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
}

HTTPAUTH_API void LoginHook(pGinaInfo *settingsInfo)
{
}

HTTPAUTH_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

HTTPAUTH_API BOOL IsRequired(void)
{
	return false; // default to false if we get here
}

/**
	@brief	Writes a string to the registry
	@author Nathan Yocom
    
    Writes the passed string to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       String to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteString(LPTSTR value,LPCTSTR location)
{
    HKEY hKey;
    
    if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAUTHing"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS)
    {
        if(value != NULL)
            if(RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey(hKey);
                RegCloseKey(hKey);
                return true;
            }
    }
    
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

/**
	@brief	Writes a boolean (as dword) to the registry
	@author Nathan Yocom
    
    Writes the passed boolean to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       Boolean to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteBool(BOOL value,LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = (value ? 1 : 0);
        
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
        if(RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey(hKey);
            RegCloseKey(hKey);
            return true;
        }
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

/**
	@brief	Reads a string to the registry
	@author Nathan Yocom
    
    Reads the indicated location under HKLM\\Software\\pGina and return it
    
    @param  location    Name of the value to read
    
    @retval TCHAR*  A newly allocated TCHAR[] with the read value (up to 2048 chars)
    
    @bug    Buffer expansion issue here?
*/
TCHAR * regReadString(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);
        
        if(lResult == ERROR_SUCCESS)
        {
            if(dwBytesRead > 0)
            {
				if(!_tcscmp(result,TEXT(""))) // If its just a space
				{
				    return NULL;                                                                                 
				}
				else
				{
					ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
            }
            else
            {
                return NULL;
            }
        }
    }
    RegCloseKey(hKey);
    return NULL;
}

/**
	@brief	Load a bool value from the HKLM/pGina registry
	@author Nathan Yocom
    
    @param location The key to load
*/
BOOL regReadBool(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);
        
        if(lResult == ERROR_SUCCESS)
        {
            RegCloseKey(hKey);
            if(value == 1) 
                return true;
            else
                return false;
        }
    }
    RegCloseKey(hKey);
    return false;
}

BOOL regWriteDword(DWORD value,LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = value;
        
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
        if(RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey(hKey);
            RegCloseKey(hKey);
            return true;
        }
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

DWORD regReadDword(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\HTTPAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);
        
        if(lResult == ERROR_SUCCESS)
        {
            RegCloseKey(hKey);
            return value;
        }
    }
    RegCloseKey(hKey);
    return 0;
}

char * convert_to_char(const TCHAR *from)
{
	if(from == NULL)
		return NULL;
	char *to = (char *) malloc(wcslen(from)+1);
	
	WideCharToMultiByte(CP_ACP,
						NULL,
						(LPCWSTR)from,
						-1,
						to,
						wcslen(from)+1,
						NULL,
						NULL);
	
	return to;
}

CString convert_to_wchar(const char *from)
{
	TCHAR *to;
	if(from == NULL)
		return NULL;
	to = (TCHAR *) malloc(strlen(from)*sizeof(TCHAR));
	MultiByteToWideChar(CP_ACP,
						NULL,
						(LPCSTR)from,
						strlen(from)+1,
						(LPWSTR)to,
						strlen(from)*sizeof(TCHAR));					

	CString temp = to;
	return temp;
}
