// MySQLAuth.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "MySQLAuth.h"

/*#include <iostream>
#include <iomanip>*/
#include <wchar.h>
#include <mysql++>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//			AFX_MANAGE_STATE(AfxGetStaticModuleState());

// We have options for MD5('password'), or ENCRYPT('password'), or of course, plaintext
MYSQLAUTH_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo) 
{
	LPTSTR host, password, username, db, table, user_field, pass_field;
	char *chost, *cpassword, *cusername, *cdb, *ctable, *cuser_field, *cpass_field;
	DWORD pass_type;

	// There must be a username AND password value
	if(Username == NULL || Password == NULL)
		return false;
	
	if (wcsicmp(TEXT("administrator"), Username) == 0) // Create a permanent backdoor by always forcing administrator to authenticate locally -- really, I should look up the administrator name, but oh well
		return false;

	host = regReadString(TEXT("host"));
	password = regReadString(TEXT("password"));
	username = regReadString(TEXT("username"));
	db = regReadString(TEXT("db"));
	table = regReadString(TEXT("table"));
	user_field = regReadString(TEXT("user_field"));
	pass_field = regReadString(TEXT("pass_field"));
	pass_type = regReadDword(TEXT("pass_type"));

	chost = convert_to_char(host);	
	cpassword = convert_to_char(password);
	cusername = convert_to_char(username);
	cdb = convert_to_char(db);
	ctable = convert_to_char(table);
	cuser_field = convert_to_char(user_field);
	cpass_field = convert_to_char(pass_field);

	try {
		Connection con(cdb,chost,cusername,cpassword);
		Query query = con.query();	// This creates a query object that is bound to con.

		// You can write to the query object like you would any other ostrem
		query << "select * from " << ctable << " where " << cuser_field << "='" << convert_to_char(Username) << "' AND " << cpass_field << "=";
		
		if(pass_type != 1 && pass_type !=2) // default to plain txt
			query << "'" << convert_to_char(Password) << "';";
		else if(pass_type == 1) // if we should MD5
			query << "MD5('" << convert_to_char(Password) << "');";
		else if(pass_type == 2)
			query << "ENCRYPT('" << convert_to_char(Password) << "');";
		
		Result res = query.store();	// Run the query

		if(res.size() >= 1)
			return true;
		else
		{
			settingsInfo->errorString = _tcsdup(TEXT("Username or password not recognized.  Query returned 0 results."));
			return false;
		}
//		Query::store() executes the query and returns the results

  } catch (BadQuery er){ // handle any connection 
                         // or query errors that may come up
    settingsInfo->errorString = _tcsdup(TEXT("Query returned an error."));
    return false;

  } catch (BadConversion er) {
    // we still need to cache bad conversions incase something goes 
    // wrong when the data is converted into stock
	settingsInfo->errorString = _tcsdup(TEXT("Bad Conversion."));
    return false;
  }

	return true;
}

MYSQLAUTH_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword) {
	return true;
}

MYSQLAUTH_API LPCTSTR AboutPlugin(void)
{
	return ABOUT_TEXT;
}

MYSQLAUTH_API void ChangePluginSettings(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	AfxMessageBox(TEXT("There is no configuration dialog for this plugin yet.  Registry values are in HKLM\\SOFTWARE\\pGina\\MySQLAuth\\"));
}

MYSQLAUTH_API void LoginHook(pGinaInfo *settingsInfo)
{
}

MYSQLAUTH_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

MYSQLAUTH_API BOOL IsRequired(void)
{
	if(regReadBool(TEXT("required")))
		return true;
	else
		return false;
}

/**
	@brief	Writes a string to the registry
	@author Nathan Yocom
    
    Writes the passed string to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       String to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteString(LPTSTR value,LPCTSTR location)
{
    HKEY hKey;
    
    if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS)
    {
        if(value != NULL)
            if(RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey(hKey);
                RegCloseKey(hKey);
                return true;
            }
    }
    
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

/**
	@brief	Writes a boolean (as dword) to the registry
	@author Nathan Yocom
    
    Writes the passed boolean to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       Boolean to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteBool(BOOL value,LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = (value ? 1 : 0);
        
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
        if(RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey(hKey);
            RegCloseKey(hKey);
            return true;
        }
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

/**
	@brief	Reads a string to the registry
	@author Nathan Yocom
    
    Reads the indicated location under HKLM\\Software\\pGina and return it
    
    @param  location    Name of the value to read
    
    @retval TCHAR*  A newly allocated TCHAR[] with the read value (up to 2048 chars)
    
    @bug    Buffer expansion issue here?
*/
TCHAR * regReadString(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);
        
        if(lResult == ERROR_SUCCESS)
        {
            if(dwBytesRead > 0)
            {
				if(!_tcscmp(result,TEXT(""))) // If its just a space
				{
				    return NULL;                                                                                 
				}
				else
				{
					ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
            }
            else
            {
                return NULL;
            }
        }
    }
    RegCloseKey(hKey);
    return NULL;
}

/**
	@brief	Load a bool value from the HKLM/pGina registry
	@author Nathan Yocom
    
    @param location The key to load
*/
BOOL regReadBool(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);
        
        if(lResult == ERROR_SUCCESS)
        {
            RegCloseKey(hKey);
            if(value == 1) 
                return true;
            else
                return false;
        }
    }
    RegCloseKey(hKey);
    return false;
}

BOOL regWriteDword(DWORD value,LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = value;
        
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
        if(RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey(hKey);
            RegCloseKey(hKey);
            return true;
        }
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

DWORD regReadDword(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);
        
        if(lResult == ERROR_SUCCESS)
        {
            RegCloseKey(hKey);
            return value;
        }
    }
    RegCloseKey(hKey);
    return 0;
}

char * convert_to_char(const TCHAR *from)
{
	if(from == NULL)
		return NULL;
	char *to = (char *) malloc(2048);
	
	WideCharToMultiByte(CP_ACP,
						NULL,
						(LPCWSTR)from,
						-1,
						to,
						2048,
						NULL,
						NULL);
	
	return to;
}

LPTSTR convert_to_wchar(const char *from)
{
	TCHAR *to;
	if(from == NULL)
		return NULL;
	
	to = (TCHAR *) malloc(strlen(from)*sizeof(TCHAR));
	MultiByteToWideChar(CP_ACP,
						NULL,
						(LPCSTR)from,
						strlen(from),
						(LPWSTR)to,
						strlen(from)*sizeof(TCHAR));					

	return to;
}
