/*
pGina POPAuth Plugin
Copyright 2003, Joseph Robinson


This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.


This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.


Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/
// ConfigDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SamplePlugin.h"
#include "ConfigDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog dialog


CConfigDialog::CConfigDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigDialog)
	m_version = _T("");
	m_host = _T("");
	//}}AFX_DATA_INIT
	m_version = VERSION;
	m_host = regReadString(TEXT("host"));
}


void CConfigDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDialog)
	DDX_Text(pDX, IDC_VERSION, m_version);
	DDX_Text(pDX, IDC_HOST, m_host);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDialog, CDialog)
	//{{AFX_MSG_MAP(CConfigDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog message handlers

void CConfigDialog::OnCancel() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();	
}

void CConfigDialog::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	
	if(m_host.GetLength() > 0)
		regWriteString(m_host.GetBuffer(m_host.GetLength()),L"host");
	else
		regWriteString(L"",L"host");

	UpdateData(FALSE);
	CDialog::OnOK();
}
