; $Id: RADIUSplugin.iss,v 1.5.2.1 2005/03/14 14:56:02 hweiss Exp $
;
; RADIUS Plugin for pGina | Inno Setup (http://www.jrsoftware.org/)

[Setup]
AppName=RADIUSplugin
AppVerName=RADIUS Plugin for pGina 0.2.1
AppPublisher=Holger Wei (ZEDAT | Freie Universitt Berlin)
AppPublisherURL=http://pgina.xpasystems.com/plugins/radius.php
AppSupportURL=http://pgina.xpasystems.com/plugins/radius.php
AppUpdatesURL=http://pgina.xpasystems.com/plugins/radius.php
DefaultDirName=C:\pGina\plugins
DefaultGroupName=pGina\RADIUSplugin
PrivilegesRequired=admin
AllowNoIcons=yes
LicenseFile=..\Documentation\license.txt
Compression=bzip/9

[Files]
Source: ..\System\MFC71u.dll; DestDir: {sys}; MinVersion: 0, 4; Flags: restartreplace uninsneveruninstall regserver noregerror
Source: ..\System\msvcr71.dll; DestDir: {sys}; Flags: restartreplace uninsneveruninstall
Source: ..\RADIUSplugin\Release\RADIUSplugin.dll; DestDir: {app}; Flags: ignoreversion restartreplace
Source: ..\Documentation\RADIUSplugin.pdf; DestDir: {app}\..\docs; Flags: ignoreversion
Source: ..\Documentation\RADIUSplugin.doc; DestDir: {app}\..\docs; Flags: ignoreversion
Source: ..\Documentation\RADIUSplugin.txt; DestDir: {app}\..\docs; Flags: ignoreversion isreadme
Source: ..\Documentation\dictionary.ntua; DestDir: {app}\..\docs; Flags: ignoreversion
Source: ..\RADIUSplugin\Changes.txt; DestDir: {app}\..\docs; Flags: ignoreversion
Source: ..\RADIUSplugin\COPYING.txt; DestDir: {app}\..\docs; Flags: onlyifdoesntexist; DestName: gpl.txt

[INI]
Filename: {app}\..\docs\RADIUSplugin.url; Section: InternetShortcut; Key: URL; String: http://pgina.xpasystems.com/plugins/radius.php

[Icons]
Name: {group}\Documentation (PDF); Filename: {app}\..\docs\RADIUSplugin.pdf
Name: {group}\Documentation (DOC); Filename: {app}\..\docs\RADIUSplugin.doc
Name: {group}\README; Filename: {app}\..\docs\RADIUSplugin.txt
Name: {group}\Changes; Filename: {app}\..\docs\Changes.txt
Name: {group}\GPL License; Filename: {app}\..\docs\gpl.txt
Name: {group}\RADIUSplugin on the Web; Filename: {app}\..\docs\RADIUSplugin.url
Name: {group}\Uninstall RADIUSplugin; Filename: {uninstallexe}

[UninstallDelete]
Type: files; Name: {app}\..\docs\RADIUSplugin.url

[Registry]
Root: HKLM; Subkey: Software\pGina\RADIUSplugin; Flags: uninsdeletekey noerror
