// PluginSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PluginSetup.h"
#include "PluginSetupDlg.h"
#include "SelectPlugin.h"

//#include "configDiag.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPluginSetupDlg dialog

CPluginSetupDlg::CPluginSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPluginSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPluginSetupDlg)
	m_AboutPlugin = _T("");
	m_AboutHook = _T("");
	m_userGroups = _T("");
	m_homeDir = _T("");
	m_isAdmin = FALSE;
	m_mapPaths = _T("");
	m_allowPassChange = FALSE;
	m_info_password = _T("");
	m_password = _T("");
	m_new_password = _T("");
		m_pathProfile = _T("");
	m_username = _T("");
	m_info_username = _T("");
	m_domain = _T("");
	m_errorstring = _T("");
	m_req = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPluginSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPluginSetupDlg)
	DDX_Text(pDX, IDC_AboutPlugin, m_AboutPlugin);
	DDX_Text(pDX, IDC_AboutHook, m_AboutHook);
	DDX_Text(pDX, IDC_GROUPS, m_userGroups);
	DDX_Text(pDX, IDC_HOMEDIR, m_homeDir);
	DDX_Text(pDX, IDC_ISADMIN, m_isAdmin);
	DDX_Text(pDX, IDC_MAPPATHS, m_mapPaths);
	DDX_Text(pDX, IDC_PASS_CHANGE, m_allowPassChange);
	DDX_Text(pDX, IDC_PASS_INFO, m_info_password);
	DDX_Text(pDX, IDC_PASS1, m_password);
	DDX_Text(pDX, IDC_PASS2, m_new_password);
	DDX_Text(pDX, IDC_PATHPROFILE, m_pathProfile);
	DDX_Text(pDX, IDC_USERNAME, m_username);
	DDX_Text(pDX, IDC_USERNAME_INFO, m_info_username);
	DDX_Text(pDX, IDC_DOMAIN, m_domain);
	DDX_Text(pDX, IDC_error, m_errorstring);
	DDX_Text(pDX, IDC_required, m_req);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPluginSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CPluginSetupDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Settings, OnSettings)
	ON_BN_CLICKED(IDC_pGina, OnpGina)
	ON_BN_CLICKED(IDC_BUTTON1, OnLoadHook)
	ON_BN_CLICKED(IDC_BUTTON2, OnConfigureHook)
	ON_BN_CLICKED(IDC_BUTTON3, OnLoginTest)
	ON_BN_CLICKED(IDC_BUTTON4, OnLoginHook)
	ON_BN_CLICKED(IDC_BUTTON5, OnLogoutHook)
	ON_BN_CLICKED(IDC_BUTTON6, OnChangePass)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPluginSetupDlg message handlers

BOOL CPluginSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	// Setup function pointers
	dllLoaded = false;
	hookLoaded = false;
	pGinaConfigure = NULL;
	settingsInfo.mapPaths = NULL;
	settingsInfo.Password = NULL;
	settingsInfo.pathMSGina = NULL;
	settingsInfo.pathPlugin = NULL;
	settingsInfo.pathProfile = NULL;
	settingsInfo.Username = NULL;
	settingsInfo.userGroups = NULL;
	settingsInfo.isAdmin = false;
	settingsInfo.allowPassChange = false;
	settingsInfo.errorString = NULL;
	settingsInfo.defaultDomain = NULL;
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPluginSetupDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPluginSetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPluginSetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// When the user presses the "Load Plugin" button...
void CPluginSetupDlg::OnOK() 
{
	// Create a new file selection dialog box
	//    The parameters state that we want to Open a file,
	//	  hide files marked as read-only, filter for *.pgina, *.dll and *.*
	//    and we do not belong to a particular hWnd for callback.
	SelectPlugin *t = new SelectPlugin(TRUE,NULL,NULL,OFN_HIDEREADONLY, TEXT("DLL files (*.dll)|*.dll|All files (*.*)|*.*"), NULL);
	
	// Call the file selection dialog
	if(t->DoModal() == IDOK)
	{	
		// The user selected a file, or pressed okay
		//   so call LoadFunctions on the selected path.
		LoadFunctions(t->GetPathName());
		
		// If the DLL was loaded and the flag is set
		if(dllLoaded)
		{
			m_AboutPlugin = dllAboutPlugin();  // Set the caption on our app appropriatley
			if(dllIsRequired)
			{
				if(dllIsRequired())
					m_req = "True";
				else
					m_req = "False";
			}
			else m_req = "False";
		}
	}
	else
	{
		// If we get here the user canceled the open process
		m_AboutPlugin = "";
	}
	// Update the form with any new information (read FROM variables)
	UpdateData(FALSE); 
}

// Utility function to map methods from within a pGina plugin DLL
void CPluginSetupDlg::LoadFunctions(LPCTSTR DLLFile)
{
	// A handle to our DLL File
	HINSTANCE hDll;

	// See if we can get into the DLL and find the lookup tables
	if(!(hDll = LoadLibrary(DLLFile)))
	{
		// The loaded file was not of the appropriate DLL format
		MessageBox(TEXT("Not a DLL, try again."),TEXT("SHIT!"),MB_OK);
	}
	else
	{
		// Map the methods from the DLL to local namespace and make them 'callable'
		dllUserLogin = (DLLUSERLOGIN) GetProcAddress(hDll,"UserLogin");
		dllChangeUserPassword = (DLLCHANGEUSERPASSWORD) GetProcAddress(hDll,"ChangeUserPassword");
		dllAboutPlugin = (DLLABOUTPLUGIN) GetProcAddress(hDll,"AboutPlugin");
		dllChangePluginSettings = (DLLCHANGEPLUGINSETTINGS) GetProcAddress(hDll,"ChangePluginSettings");
		dllLoginHook = (DLLLOGINHOOK) GetProcAddress(hDll,"LoginHook");
		dllLogoutHook = (DLLLOGOUTHOOK) GetProcAddress(hDll,"LogoutHook");
		dllIsRequired = (DLLISREQUIRED) GetProcAddress(hDll,"IsRequired");
		// If any of them were NOT loaded
		if(!dllUserLogin || !dllChangeUserPassword || !dllAboutPlugin || !dllChangePluginSettings || !dllLoginHook)
		{
			// Tell the user something was missing/wrong
			MessageBox(TEXT("This does not appear to be a valid or complete pGina plugin."),TEXT("Error Loading"),MB_OK);
			// DONT say we loaded it
			dllLoaded = false;
		}
		else
		{
			// Everything is cool, its all loaded
			dllLoaded = true;
		}
	}
}

// When the user presses the "Plugin Settings" button...
void CPluginSetupDlg::OnSettings() 
{
	// Cant do anything if the plugin hasnt been mapped
	if(dllLoaded)
		dllChangePluginSettings();	// Call the ChangePluginSettings method in the plugin
	else
		MessageBox(TEXT("You must load a plugin first.")); // or warn the user...
}

// When user presses the "Configure pGina" button...
void CPluginSetupDlg::OnpGina() 
{

	if(pGinaConfigure == NULL)
	{
		// Handle to our dll
		HINSTANCE hDll;

		// Setup our file selection dialog as previously
		SelectPlugin *t = new SelectPlugin(TRUE,NULL,NULL,OFN_HIDEREADONLY, TEXT("PGINA.DLL files (pgina.dll)|pgina.dll|All files (*.*)|*.*"), NULL);
		
		// Show our file selection dialog and get the users selection
		if(t->DoModal() == IDOK)
		{	
			// Load the selected DLL
			if(!(hDll = LoadLibrary(t->GetPathName())))
			{
				// Hmm... not a DLL?
				MessageBox(TEXT("Error loading pGina!"),TEXT("SHIT!"),MB_OK);
				exit(0);
			}

			// Map the pGinaConfigure() method, if possible
			if(!(pGinaConfigure = (DLLCONFIGURE) GetProcAddress(hDll,"pGinaConfigure")))
			{
				// Tell the user it wasnt there!
				MessageBox(TEXT("This does not appear to be a valid pGina."),TEXT("Error loading"),MB_OK);	
			}
			else
			{
				pGinaConfigure();
			}
		}

		// Not really necessary, but can't hurt.
		UpdateData(FALSE); 
		//configDiag *configure = new configDiag();
		//configure->DoModal();
	}
	else
	{
		pGinaConfigure();
	}
}

void CPluginSetupDlg::OnLoadHook() 
{
	// TODO: Add your control notification handler code here
	SelectPlugin *t = new SelectPlugin(TRUE,NULL,NULL,OFN_HIDEREADONLY, TEXT("DLL files (*.dll)|*.dll|All files (*.*)|*.*"), NULL);
	
	// Call the file selection dialog
	if(t->DoModal() == IDOK)
	{	
		// The user selected a file, or pressed okay
		//   so call LoadFunctions on the selected path.
		LoadHook(t->GetPathName());
		
		// If the DLL was loaded and the flag is set
		if(hookLoaded)
			m_AboutHook = hookAboutHook();  // Set the caption on our app appropriatley
	}
	else
	{
		// If we get here the user canceled the open process
		m_AboutHook = "";
	}
	// Update the form with any new information (read FROM variables)
	UpdateData(FALSE); 
}

void CPluginSetupDlg::OnConfigureHook() 
{
	// TODO: Add your control notification handler code here
	if(hookLoaded)
		hookChangeHookSettings();
	else
		MessageBox(TEXT("You must load a hook library first!"),TEXT("Error"),MB_OK);
}

void CPluginSetupDlg::LoadHook(LPCTSTR DLLFile)
{
	HINSTANCE hDll;

	// See if we can get into the DLL and find the lookup tables
	if(!(hDll = LoadLibrary(DLLFile)))
	{
		// The loaded file was not of the appropriate DLL format
		MessageBox(TEXT("Not a DLL, try again."),TEXT("SHIT!"),MB_OK);
	}
	else
	{
		// Map the methods from the DLL to local namespace and make them 'callable'
		hookAboutHook = (DLLABOUTHOOK) GetProcAddress(hDll,"AboutHook");
		hookChangeHookSettings = (DLLCHANGEHOOKSETTINGS) GetProcAddress(hDll,"ChangeHookSettings");
		
		// If any of them were NOT loaded
		if(!hookAboutHook || !hookChangeHookSettings)
		{
			if(!hookAboutHook)
				MessageBox(TEXT("AboutHook"),TEXT("E"),MB_OK);
			if(!hookChangeHookSettings)
				MessageBox(TEXT("config"),TEXT("E"),MB_OK);
			// Tell the user something was missing/wrong
			MessageBox(TEXT("This does not appear to be a valid or complete pGina hook library."),TEXT("Error Loading"),MB_OK);
			// DONT say we loaded it
			hookLoaded = false;
		}
		else
		{
			// Everything is cool, its all loaded
			hookLoaded = true;
		}
	}
}

void CPluginSetupDlg::OnLoginTest() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	settingsInfo.Username = _tcsdup(m_username);
	settingsInfo.Password = _tcsdup(m_password);
	settingsInfo.errorString = NULL;
	if(dllLoaded)
	{
		if(dllUserLogin(settingsInfo.Username, settingsInfo.Password, &settingsInfo))
		{
			MessageBox(TEXT("Login was a success"),TEXT("Success"),MB_OK);
			m_info_username = settingsInfo.Username;
			m_info_password = settingsInfo.Password;
			m_mapPaths = settingsInfo.mapPaths;
			m_homeDir = settingsInfo.homeDir;
			m_pathProfile = settingsInfo.pathProfile;
			m_userGroups = settingsInfo.userGroups;
			m_allowPassChange = settingsInfo.allowPassChange;
			m_isAdmin = settingsInfo.isAdmin;
			m_domain = settingsInfo.defaultDomain;
			m_errorstring = settingsInfo.errorString;
			UpdateData(FALSE);
		}
		else
			MessageBox(TEXT("Login failed"),TEXT("Error"),MB_OK);

	}
	else
		MessageBox(TEXT("You must load a plugin first."),TEXT("Error"),MB_OK);


}

void CPluginSetupDlg::OnLoginHook() 
{
	UpdateData(TRUE);
	settingsInfo.errorString = NULL;
	// TODO: Add your control notification handler code here
	if(dllLoaded)
	{
		dllLoginHook(&settingsInfo);
			
		m_info_username = settingsInfo.Username;
		m_info_password = settingsInfo.Password;
		m_mapPaths = settingsInfo.mapPaths;
		m_homeDir = settingsInfo.homeDir;
		m_pathProfile = settingsInfo.pathProfile;
		m_userGroups = settingsInfo.userGroups;
		m_allowPassChange = settingsInfo.allowPassChange;
		m_isAdmin = settingsInfo.isAdmin;
		m_domain = settingsInfo.defaultDomain;
		
		UpdateData(FALSE);
		MessageBox(TEXT("Done"),TEXT("Login Hook"),MB_OK);
	}
	else
		MessageBox(TEXT("You must load a plugin first."),TEXT("Error"),MB_OK);
	
}

void CPluginSetupDlg::OnLogoutHook() 
{
	UpdateData(TRUE);
	settingsInfo.errorString = NULL;
	// TODO: Add your control notification handler code here
	if(dllLoaded)
	{
		dllLogoutHook(&settingsInfo);
			
		m_info_username = settingsInfo.Username;
		m_info_password = settingsInfo.Password;
		m_mapPaths = settingsInfo.mapPaths;
		m_homeDir = settingsInfo.homeDir;
		m_pathProfile = settingsInfo.pathProfile;
		m_userGroups = settingsInfo.userGroups;
		m_allowPassChange = settingsInfo.allowPassChange;
		m_isAdmin = settingsInfo.isAdmin;
		m_domain = settingsInfo.defaultDomain;
		
		UpdateData(FALSE);
		MessageBox(TEXT("Done"),TEXT("Logout Hook"),MB_OK);
	}
	else
		MessageBox(TEXT("You must load a plugin first."),TEXT("Error"),MB_OK);
	
}

void CPluginSetupDlg::OnChangePass() 
{
	LPTSTR new_pass;
	UpdateData(TRUE);
	settingsInfo.errorString = NULL;
	// TODO: Add your control notification handler code here
	if(dllLoaded)
	{
		settingsInfo.Username = _tcsdup(m_username);
		settingsInfo.Password = _tcsdup(m_password);
		new_pass = _tcsdup(m_new_password);
		
		if(dllChangeUserPassword(settingsInfo.Username, settingsInfo.Password, new_pass))
		{
			m_info_username = settingsInfo.Username;
			m_info_password = settingsInfo.Password;
			m_mapPaths = settingsInfo.mapPaths;
			m_homeDir = settingsInfo.homeDir;
			m_pathProfile = settingsInfo.pathProfile;
			m_userGroups = settingsInfo.userGroups;
			m_allowPassChange = settingsInfo.allowPassChange;
			m_isAdmin = settingsInfo.isAdmin;
			m_domain = settingsInfo.defaultDomain;
			
			UpdateData(FALSE);
			MessageBox(TEXT("Plugin reported success"),TEXT("Change Password"),MB_OK);
		}
		else
			MessageBox(TEXT("Plugin reported failure"),TEXT("Change Password"),MB_OK);
	}
	else
		MessageBox(TEXT("You must load a plugin first."),TEXT("Error"),MB_OK);
	
}
