/*
	pGina - Pluggable GINA authentication DLL for Windows
    Copyright (C) 2001  Nathan Yocom, Michael Wright

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Email: yocomnw@plu.edu
    Web: http://pgina.cs.plu.edu
    Mail: 
       Nathan Yocom @ CSCE
       Pacific Lutheran University
       Tacoma, WA 98447 (USA)
    Phone: 253-535-7400
*/
#if !defined(AFX_CONFIGDIAG_H__7237D6FA_E644_4625_8792_9B0DDCA2DE04__INCLUDED_)
#define AFX_CONFIGDIAG_H__7237D6FA_E644_4625_8792_9B0DDCA2DE04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// configDiag.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// configDiag dialog
#include "resource.h"
#include "stdafx.h"
#include "pGinaInterface.h"
typedef __declspec(dllimport) LPSTR (*DLLABOUTPLUGIN) (void);

#if !defined(INFO_STRUCT)
#define INFO_STRUCT 1
typedef struct pGinaInfo {
		LPSTR pathMSGina;
		LPSTR pathPlugin;
		LPSTR pathProfile;
		LPSTR mapPaths;
		LPSTR Username;
		LPSTR Password;
} pGinaInfo;
#endif


// These functions are in pGina
//BOOL pGinaSaveInfo(pGinaInfo *);
//BOOL pGinaLoadInfo(pGinaInfo *);
//LPSTR stlps(CString);

class configDiag : public CDialog
{
// Construction
public:
	configDiag(CWnd* pParent = NULL);   // standard constructor
	void getPluginInfo(void);
	pGinaInterface * pGinaFuncs;
	// Setup to get plugin Information

	DLLABOUTPLUGIN				pAboutPlugin;
// Dialog Data
	//{{AFX_DATA(configDiag)
	enum { IDD = IDD_Dialog };
	CString	m_mapPaths;
	CString	m_pathMSGina;
	CString	m_pathPlugin;
	CString	m_pathProfile;
	CString	m_PluginInfo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(configDiag)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(configDiag)
	afx_msg void OnSave();
	afx_msg void OnLoad();
	afx_msg void OnChangepathPlugin();
	afx_msg void OnBrowseMSGina();
	afx_msg void OnBrowsePlugin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGDIAG_H__7237D6FA_E644_4625_8792_9B0DDCA2DE04__INCLUDED_)
