/*************************************************************************

         AFS Plugin for pGina version 0.8 beta
         (c) 2003 by Martin Decky

         Distributed under the terms of GNU General Public License,
         see COPYING for details.

*************************************************************************/

#define AFSPLUGIN_API extern "C" __declspec(dllexport)

#define AFSPLUGIN_VERSION "0.9"

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo;

AFSPLUGIN_API BOOL UserLogin(LPTSTR, LPTSTR, pGinaInfo * );			
AFSPLUGIN_API BOOL ChangeUserPassword(LPTSTR, LPTSTR, LPTSTR);
AFSPLUGIN_API void ChangePluginSettings(void);
AFSPLUGIN_API void LoginHook(pGinaInfo * );
AFSPLUGIN_API void LogoutHook(pGinaInfo * );
AFSPLUGIN_API BOOL IsRequired(void);
