/** 
	@file ConfigAbout.cpp
	@brief About box handler written by Michael Morris (mikelmorris@knology.net)
*/
/*
pGina ldapAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2002 Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: coopermj@muohio.edu
Snail Mail:
	Micah Cooper
	212A Kreger Hall
	Miami University
	Oxford OH  45056
*/
// ConfigAbout.cpp : implementation file
//

#include "stdafx.h"
#include "ldapauth_plus.h"
#include "ConfigAbout.h"
#include ".\configabout.h"


// CConfigAbout dialog

IMPLEMENT_DYNAMIC(CConfigAbout, CDialog)
CConfigAbout::CConfigAbout(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigAbout::IDD, pParent)
	//, m_version(LDAPAUTHABOUT)
{
	m_version = L"\n\n\n\nLDAPAuth v1.5\n\nby\n\nMicah Cooper (coopermj@muohio.edu) \nand\n Michael Morris (mikelmorris@knology.net)";
}

CConfigAbout::~CConfigAbout()
{
}

void CConfigAbout::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_VERSION, m_version);
}


BEGIN_MESSAGE_MAP(CConfigAbout, CDialog)
	ON_STN_CLICKED(IDC_VERSION, OnStnClickedVersion)
END_MESSAGE_MAP()

void CConfigAbout::OnOK()
{
	return;
}

// CConfigAbout message handlers

void CConfigAbout::OnStnClickedVersion()
{
	// TODO: Add your control notification handler code here
}
