/*
pGina POPAuth Plugin
Copyright 2003, Joseph Robinson


This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.


This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.


Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/
// SamplePlugin.h : main header file for the SAMPLEPLUGIN DLL
//

#if !defined(AFX_SAMPLEPLUGIN_H__10388950_7A30_4390_8478_2338F6A1524B__INCLUDED_)
#define AFX_SAMPLEPLUGIN_H__10388950_7A30_4390_8478_2338F6A1524B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#define SAMPLEPLUGIN_API extern "C" __declspec(dllexport)
#define VERSION TEXT("POPAuth pGina Plugin Version 0.9.2 by Joseph Robinson, extended by Nathan Yocom, Melvin Lasky and Randy Dixon");

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;


SAMPLEPLUGIN_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
SAMPLEPLUGIN_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
SAMPLEPLUGIN_API LPCTSTR AboutPlugin(void);
SAMPLEPLUGIN_API void ChangePluginSettings(void);
SAMPLEPLUGIN_API void LoginHook(pGinaInfo *);
SAMPLEPLUGIN_API	void LogoutHook(pGinaInfo *);
SAMPLEPLUGIN_API BOOL IsRequired(void);


TCHAR * regReadString(LPCTSTR location);
BOOL regWriteString(LPTSTR value,LPCTSTR location);






/////////////////////////////////////////////////////////////////////////////
// CSamplePluginApp
// See SamplePlugin.cpp for the implementation of this class
//

class CSamplePluginApp : public CWinApp
{
public:
	CSamplePluginApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSamplePluginApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSamplePluginApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPLEPLUGIN_H__10388950_7A30_4390_8478_2338F6A1524B__INCLUDED_)

