/*
pGina ldapAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2002 Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: coopermj@muohio.edu
Snail Mail:
	Micah Cooper
	212A Kreger Hall
	Miami University
	Oxford OH  45056
*/
#pragma once

#include "Resource.h"

// CConfigPwd dialog

class CConfigPwd : public CDialog
{
	DECLARE_DYNAMIC(CConfigPwd)

public:
	CConfigPwd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CConfigPwd();

// Dialog Data
	enum { IDD = IDD_PWD_TAB };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	  BOOL m_requireLower;
	  BOOL m_requireUpper;
	  BOOL m_requireNumeric;
	  BOOL m_requireSpecial;
	  CString m_pwdMinLength;
	  BOOL m_disablePwd;
	  CString m_restrictChars;
	  
	  afx_msg BOOL OnInitDialog();
	  afx_msg void OnOK();
	  afx_msg void OnDisableChangePwd();
	  afx_msg void OnSave();

	  CButton c_disablePwd;
	  CStatic c_minLengthText;
	  CEdit c_pwdLenValue;
	  CSpinButtonCtrl c_minSpin;
	  CButton c_restrictChars;
	  CStatic c_restrictText;
	  CStatic c_requiredText;
	  CButton c_lowerCase;
	  CButton c_upperCase;
	  CButton c_numeric;
	  CButton c_special;
};
