[Setup]
PrivilegesRequired=admin
AppName=LDAPAuth Plugin for pGina
AppVerName=LDAPAuth Plugin Version 1.5 for pGina
AppPublisher=XPA Systems
AppPublisherURL=http://www.xpasystems.com
AppSupportURL=http://www.xpasystems.com
AppUpdatesURL=http://www.xpasystems.com
DefaultDirName=c:\pGina\plugins\ldapauth
DisableDirPage=no
DefaultGroupName=pGina
DisableProgramGroupPage=no
LicenseFile=license.txt

[Files]
source: "ldapauth_plus.dll"; DestDir: "{app}";
source: "ldapauth.chm"; DestDir: "{app}\docs";
source: "MacOSXConfig.exe"; DestDir: "{app}";
source: "BynariConfig4.exe"; DestDir: "{app}";
source: "ReadMe.txt"; DestDir: "{app}\docs"

source: "mfc71.dll"; DestDir: "{sys}";
source: "mfc71u.dll"; DestDir: "{sys}";
source: "msvcr71.dll"; DestDir: "{sys}";


source: "gpl.txt"; DestDir: "{app}\docs";

[Icons]
Name: "{userprograms}\pGina\LDAPAuth 1.5\LDAPAuth Help"; Filename: "{app}\docs\ldapauth.chm"
Name: "{userprograms}\pGina\LDAPAuth 1.5\GPL"; Filename: "{app}\docs\gpl.txt"
Name: "{userprograms}\pGina\LDAPAuth 1.5\Uninstall"; Filename: "{uninstallexe}"
Name: "{userprograms}\pGina\LDAPAuth 1.5\Wizard (Mac OSX)"; Filename: "{app}\MacOSXConfig.exe"
Name: "{userprograms}\pGina\LDAPAuth 1.5\Wizard (Bynari IS 4.x)"; Filename: "{app}\BynariConfig4.exe"

[Messages]
FinishedLabel=Setup has finished installing [name] on your computer.%n%nHowever, it has NOT been set as your default plugin. Please verify the configuration, test, then set the plugin value in pGina to point to the location you chose to install this plugin.%n%nShould you want debug output from the plugin, use the ldapauth_plus_debug.dll plugin, otherwise use the standard ldapauth_plus.dll plugin.
FinishedLabelNoIcons=Setup has finished installing [name] on your computer.%n%nHowever, it has NOT been set as your default plugin. Please verify the configuration, test, then set the plugin value in pGina to point to the location you chose to install this plugin.%n%nShould you want debug output from the plugin, use the ldapauth_plus_debug.dll plugin, otherwise use the standard ldapauth_plus.dll plugin.

[Run]
Filename: "{app}\MacOSXConfig.exe"; Description: "Mac OSX Configuration Wizard"; Flags: unchecked nowait postinstall skipifsilent
Filename: "{app}\BynariConfig4.exe"; Description: "Bynari InsightServer Configuration Wizard"; Flags: unchecked nowait postinstall skipifsilent
Filename: "{app}\docs\ReadMe.txt"; Description: "View ReadMe"; Flags: postinstall skipifsilent shellexec

