using System;
using Microsoft.Win32;

namespace ldapauthupdater
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			int i = 0;

			foreach(string str in args)
			{
				convertKey(str.Trim());
			}
		}
		public static void convertKey(string myKey) 
		{
			Int32 numVal;
			string status;

			try
			{
				// Create a reference to a valid key.  For this code to
				// work, the indicated subkey must have been created 
				// previously.  The key name is not case-sensitive.
				RegistryKey rk = Registry.LocalMachine.OpenSubKey("Software\\pGina\\ldapauth", true);

				// Get the data from a specified item in the key.
				String s = (String)rk.GetValue(myKey);

				// convert the string to a number value
				numVal = Int32.Parse(s);

				status = "Converting: " + myKey + " with value: " + s;
				rk.SetValue(myKey, numVal);

			}
			catch (Exception e)
			{
				status = "A problem occurred with " + myKey;
			}

			Console.WriteLine(status);

		}

	}

}
