/*
pGina Dummy plugin example code - skeleton code for pGina plugin development
Copyright (C) 2002 Nathan Yocom, Michael Wright

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
http://pgina.cs.plu.edu
Email: nate@yocom.org
Snail Mail:
  Nathan Yocom
  9 Evergreen Farms Rd
  Scarborough, ME 04074
  Phone: 207-450-4948
*/

// Define macro's for exporting methods
#ifdef DUMMYPLUGIN_EXPORTS
#define DUMMYPLUGIN_API extern "C" __declspec(dllexport)
#else
#define DUMMYPLUGIN_API extern "C" __declspec(dllimport)
#endif

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;



// Export these methods... - REQUIRED
DUMMYPLUGIN_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
DUMMYPLUGIN_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
DUMMYPLUGIN_API LPCTSTR AboutPlugin(void);
DUMMYPLUGIN_API void ChangePluginSettings(void);
DUMMYPLUGIN_API void LoginHook(pGinaInfo *);
DUMMYPLUGIN_API	void LogoutHook(pGinaInfo *);

// Option method with the 1.6.x series and up of pGina
DUMMYPLUGIN_API BOOL IsRequired(void);


